/* -*- mode: c ; c-file-style: "canonware-c-style" -*-
 ******************************************************************************
 *
 * Copyright (C) 1996-2004 Jason Evans <jasone@canonware.com>.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice(s), this list of conditions and the following disclaimer
 *    unmodified other than the allowable addition of one or more
 *    copyright notices.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice(s), this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER(S) ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 *
 * Version: Onyx 5.1.1
 *
 ******************************************************************************/

#include "../include/libonyx/libonyx.h"

#define NITERATIONS 5
#define NINTERPS 3

void *
thread_entry_func(void *a_arg)
{
    cw_nx_t nx;
    cw_nxo_t thread;
    uint32_t i;

    cw_assert(nx_new(&nx, NULL, NULL) == &nx);
    nxo_thread_new(&thread, &nx);

    for (i = 0; i < NITERATIONS; i++)
    {
	cw_onyx_code(&thread, "10000 {[`a' `b' `c']} repeat clear");
	fprintf(stderr, ".");
    }
/*     cw_onyx_code(&thread, "gcdict $stats get eval 2 sprint"); */

    nx_delete(&nx);
    return NULL;
}

int
main(int argc, char **argv, char **envp)
{
    cw_thd_t *thds[NINTERPS];
    uint32_t i;

    fprintf(stderr, "Test begin\n");
    libonyx_init(argc, argv, envp);

    for (i = 0; i < NINTERPS; i++)
    {
	thds[i] = thd_new(thread_entry_func, NULL, true);
    }

    for (i = 0; i < NINTERPS; i++)
    {
	thd_join(thds[i]);
    }

#if (0)
    {
	cw_nx_t nx;
	cw_nxo_t thread;

	cw_assert(nx_new(&nx, NULL, NULL) == &nx);
	nxo_thread_new(&thread, &nx);

	fprintf(stderr, "\n");
	cw_onyx_code(&thread, "gcdict $stats get eval 2 sprint");

	nx_delete(&nx);
    }
#endif

    libonyx_shutdown();
    fprintf(stderr, "\nTest end\n");
    return 0;
}
